%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Spectrogram 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all hidden;
clear;

%Specification of function
fs =5000;               %sampling rate
a=0;b=1;
t = a:1/fs:b;           %time intervall [0,1]
%f = sin(500*pi*t.*t);   %chirp function
f = sin(400*2*pi*t)+sin(450*2*pi*t); f(1000)=10; f(2000)=10;


%Specification of parameters for spectrogram
winLength = 256;
ov = ceil(winLength/2);
%ov = 1000;
win = hanning(winLength);
%win = boxcar(winLength);
nfft = winLength;


%%
figure;
plot(t,f);
title('Function')
axis tight;

%%
figure;
spectrogram(f,win,ov,nfft)
title('Spectrogram')

%%
figure;
spectrogram(f,win,ov,nfft,fs)
title('Spectrogram')

%%
figure;
f_spec = spectrogram(f,win,ov,nfft,fs);
imagesc(abs(f_spec));
colorbar;

%%
figure;
axis_t = t;
axis_o = ([1:size(f_spec,1)]-1)*fs/winLength;
f_spec = spectrogram(f,win,ov,nfft,fs);
imagesc(axis_t,axis_o,log(abs(f_spec)));
axis xy;
colorbar;
xlabel('Time t')

ylabel('Frequency \omega')

