%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MATLAB-Demo: Novelty curve for onset detection
% by Meinard Mueller, 20.02.2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


clear;
close all;
window1=1;
window2=2;

window_length = 2048;
%window_length = 256;
window = hanning(window_length);
overlap = fix(length(window)/2);

%[file,fs,nbits] = wavread('BB_F_Kadenz_stacc_a.wav');
[file,fs,nbits] =  wavread('SYS_tonleiter1b_midi_helga.wav');
%[file,fs,nbits] =  wavread('fk_zuerich_11025_stereo.wav');

%make "mono" from "stereo"
file = file(:,1);

[B,f,t]=specgram(file,window_length,fs,window,overlap);

%spectral energy for each windowed frame
energy_frame = sqrt(sum(abs(B).^2));

%difference of spectral energy between neighboring frames
energy_diff_frame = diff(energy_frame);

%novelty curve
temp = [zeros(length(f),1) B];
temp(:,end)=[];
novelity = sum(abs(abs(B)-abs(temp)));

%plots
figure;
subplot(4,1,1)
plot(file)
title('Signal f, spectral energy (frames), \Delta(spectral energy), novelty curve') 
axis([1,length(file),min(file),max(file)])
subplot(4,1,2)
plot(t,energy_frame)
axis([min(t),max(t),min(energy_frame),max(energy_frame)])
subplot(4,1,3)
plot(t,[0 energy_diff_frame])
axis([min(t),max(t),min(energy_diff_frame),max(energy_diff_frame)])
subplot(4,1,4)
plot(t,novelity)
axis([min(t),max(t),min(novelity),max(novelity)])